# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_disk`](#dsc_disk): The DSC Disk resource type. Automatically generated from version 4.9.0.0
* [`dsc_diskaccesspath`](#dsc_diskaccesspath): The DSC DiskAccessPath resource type. Automatically generated from version 4.9.0.0
* [`dsc_mountimage`](#dsc_mountimage): The DSC MountImage resource type. Automatically generated from version 4.9.0.0
* [`dsc_opticaldiskdriveletter`](#dsc_opticaldiskdriveletter): The DSC OpticalDiskDriveLetter resource type. Automatically generated from version 4.9.0.0
* [`dsc_waitfordisk`](#dsc_waitfordisk): The DSC WaitForDisk resource type. Automatically generated from version 4.9.0.0
* [`dsc_waitforvolume`](#dsc_waitforvolume): The DSC WaitForVolume resource type. Automatically generated from version 4.9.0.0

## Resource types

### `dsc_disk`

The DSC Disk resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_disk` type.

##### `dsc_allocationunitsize`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the allocation unit size to use when formatting the volume.

##### `dsc_allowdestructive`

Data type: `Optional[Boolean]`

Specifies if potentially destructive operations may occur.

##### `dsc_cleardisk`

Data type: `Optional[Boolean]`

Specifies if the disks partition schema should be removed entirely, even if data and OEM partitions are present. Only possible with AllowDestructive enabled.

##### `dsc_diskid`

Data type: `String`

Specifies the disk identifier for the disk to modify.

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

Specifies the identifier type the DiskId contains. Defaults to Number.

##### `dsc_fsformat`

Data type: `Optional[Enum['NTFS', 'ReFS']]`

Specifies the file system format of the new volume.

##### `dsc_fslabel`

Data type: `Optional[String]`

Define volume label if required.

##### `dsc_partitionstyle`

Data type: `Optional[Enum['MBR', 'GPT']]`

Specifies the partition style of the disk. Defaults to GPT.

##### `dsc_size`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the size of new volume. Leave empty to use the remaining free space.

#### Parameters

The following parameters are available in the `dsc_disk` type.

##### `dsc_driveletter`

namevar

Data type: `String`

Specifies the identifier for which disk to modify.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_diskaccesspath`

The DSC DiskAccessPath resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_diskaccesspath` type.

##### `dsc_allocationunitsize`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the allocation unit size to use when formatting the volume.

##### `dsc_diskid`

Data type: `String`

Specifies the disk identifier for the disk to modify.

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

Specifies the identifier type the DiskId contains. Defaults to Number.

##### `dsc_fsformat`

Data type: `Optional[Enum['NTFS', 'ReFS']]`

Specifies the file system format of the new volume.

##### `dsc_fslabel`

Data type: `Optional[String]`

Define volume label if required.

##### `dsc_nodefaultdriveletter`

Data type: `Optional[Boolean]`

Specifies no automatic drive letter assignment to the partition: Defaults to True

##### `dsc_size`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Specifies the size of new volume.

#### Parameters

The following parameters are available in the `dsc_diskaccesspath` type.

##### `dsc_accesspath`

namevar

Data type: `String`

Specifies the access path folder to the assign the disk volume to.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_mountimage`

The DSC MountImage resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_mountimage` type.

##### `dsc_access`

Data type: `Optional[Enum['ReadOnly', 'ReadWrite']]`

Allows a VHD file to be mounted in read-only or read-write mode. ISO files are mounted in read-only mode regardless of what parameter value you provide.

##### `dsc_driveletter`

Data type: `Optional[String]`

Specifies the drive letter to mount this VHD or ISO to.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Determines whether the VHD or ISO should be mounted or not.

##### `dsc_storagetype`

Data type: `Optional[Enum['ISO', 'VHD', 'VHDx', 'VHDSet']]`

Specifies the storage type of a file. If the StorageType parameter is not specified, then the storage type is determined by file extension.

#### Parameters

The following parameters are available in the `dsc_mountimage` type.

##### `dsc_imagepath`

namevar

Data type: `String`

Specifies the path of the VHD or ISO file.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_opticaldiskdriveletter`

The DSC OpticalDiskDriveLetter resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_opticaldiskdriveletter` type.

##### `dsc_driveletter`

Data type: `String`

Specifies the drive letter to assign to the optical disk. Can be a single letter, optionally followed by a colon. This value is ignored if Ensure is set to Absent.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Determines whether a drive letter should be assigned to the optical disk. Defaults to 'Present'.

#### Parameters

The following parameters are available in the `dsc_opticaldiskdriveletter` type.

##### `dsc_diskid`

namevar

Data type: `String`

Specifies the optical disk number for the disk to assign the drive letter to.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_waitfordisk`

The DSC WaitForDisk resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_waitfordisk` type.

##### `dsc_diskidtype`

Data type: `Optional[Enum['Number', 'UniqueId', 'Guid', 'Location']]`

Specifies the identifier type the DiskId contains. Defaults to Number.

##### `dsc_isavailable`

Data type: `Optional[Boolean]`

Will indicate whether Disk is available.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to loop the retry interval while waiting for the disk.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of seconds to wait for the disk to become available.

#### Parameters

The following parameters are available in the `dsc_waitfordisk` type.

##### `dsc_diskid`

namevar

Data type: `String`

Specifies the disk identifier for the disk to wait for.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_waitforvolume`

The DSC WaitForVolume resource type.
Automatically generated from version 4.9.0.0

#### Properties

The following properties are available in the `dsc_waitforvolume` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to loop the retry interval while waiting for the volume.

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of seconds to wait for the volume to become available.

#### Parameters

The following parameters are available in the `dsc_waitforvolume` type.

##### `dsc_driveletter`

namevar

Data type: `String`

Specifies the drive letter of the volume to wait for.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

